import { Action, AnyAction, Dispatch, Store, Unsubscribe } from 'redux';
export interface MapStateToProps<S> {
    (state: S): object;
}
export interface PropsChangedEvent<S = any, A extends Action = AnyAction> {
    newProps: object;
    prevProps: object;
    getState(): S;
    dispatch: Dispatch<A>;
}
export interface PropsChangedHandler<S = any, A extends Action = AnyAction> {
    (event: PropsChangedEvent): void;
}
export interface Connect<S = any, A extends Action = AnyAction> {
    (mapStateToProps: MapStateToProps<S>, propsChangedHandler: PropsChangedHandler<S, A>): Unsubscribe;
}
export interface BindStoreReturn<S = any, A extends Action = AnyAction> {
    dispatch: Dispatch<A>;
    getState(): S;
    subscribe(listener: () => void): Unsubscribe;
    connect: Connect<S, A>;
}
export declare function bindStore<S = any, A extends Action = AnyAction>(store: Store<S, A>): BindStoreReturn;
